Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser_templates/studylevelmanagepage.pt
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser_templates/studylevelmanagepage.pt	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser_templates/studylevelmanagepage.pt	(revision 9169)
@@ -46,5 +46,5 @@
       </thead>
       <tbody>
-        <tr tal:repeat="value context/values" class="gradeC">
+        <tr tal:repeat="value view/translated_values" class="gradeC">
           <td>
             <input type="checkbox" name="val_id"
@@ -60,5 +60,5 @@
           <td tal:content="value/credits">CREDITS</td>
           <td tal:content="value/mandatory">MANDATORY</td>
-          <td tal:content="value/score">SCORE</td>
+          <td tal:content="value/score|nothing">SCORE</td>
           <td tal:content="value/carry_over">CO</td>
           <td tal:content="value/automatic">AUTO</td>
Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser_templates/studylevelpage.pt
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser_templates/studylevelpage.pt	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/browser_templates/studylevelpage.pt	(revision 9169)
@@ -34,6 +34,6 @@
       <th i18n:translate="">Code</th>
       <th i18n:translate="">Title</th>
-      <th i18n:translate="">Dept.</th>
-      <th i18n:translate="">Fact.</th>
+      <th i18n:translate="">Dep.</th>
+      <th i18n:translate="">Fac.</th>
       <th i18n:translate="">Cred.</th>
       <th i18n:translate="">Mand.</th>
Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/dynamicroles.py
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/dynamicroles.py	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/dynamicroles.py	(revision 9169)
@@ -51,35 +51,6 @@
         """Get roles for principal with id `principal_id`.
 
-        Different to the default implementation, this method also
-        takes into account local roles set on any department connected
-        to the context student.
-
-        If the given principal has at least one of the
-        `external_rolenames` roles granted for the external object, it
-        additionally gets `additional_rolename` role for the context
-        student.
-
-        For the additional roles the `extra_attrib` and all its parent
-        objects are looked up, because 'role inheritance' does not
-        work on that basic level of permission handling.
-
-        Some advantages of this approach:
-
-        - we don't have to store extra local roles for clearance
-          officers in ZODB for each student
-
-        - when local roles on a department change, we don't have to
-          update thousands of students; the local role is assigned
-          dynamically.
-
-        Disadvantage:
-
-        - More expensive role lookups when a clearance officer wants
-          to see an student form.
-
-        This implementation is designed to be usable also for other
-        contexts than students. You can inherit from it and set
-        different role names to lookup/set easily via the static class
-        attributes.
+        See waeup.kofa.applicants.dynamicroles.ApplicantPrincipalRoleManager
+        for further information.
         """
         apr_manager = AnnotationPrincipalRoleManager(self._context)
@@ -118,4 +89,20 @@
                         result.append(
                             ('waeup.StudentsOfficer', setting))
+                elif 'UGClearanceOfficer' in role_id:
+                    if not self._context.is_postgrad:
+                        result.append(
+                            ('waeup.StudentsClearanceOfficer', setting))
+                    else:
+                        # Otherwise grant at least view permissions.
+                        result.append(
+                            ('waeup.StudentsOfficer', setting))
+                elif 'PGClearanceOfficer' in role_id:
+                    if self._context.is_postgrad:
+                        result.append(
+                            ('waeup.StudentsClearanceOfficer', setting))
+                    else:
+                        # Otherwise grant at least view permissions.
+                        result.append(
+                            ('waeup.StudentsOfficer', setting))
                 elif role_id in self.rolename_mapping.keys():
                     # Grant additional role
Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/export.py
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/export.py	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/export.py	(revision 9169)
@@ -113,4 +113,8 @@
         if name == 'history':
             value = value.messages
+        if name == 'phone' and value is not None:
+            # Append hash '#' to phone numbers to circumvent
+            # unwanted excel automatic
+            value = str('%s#' % value)
         return super(
             StudentsExporter, self).mangle_value(
Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/interfaces.py
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/interfaces.py	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/interfaces.py	(revision 9169)
@@ -43,5 +43,5 @@
     def getValues(self, context):
         verdicts_dict = getUtility(IStudentsUtils).VERDICTS_DICT
-        return verdicts_dict.keys()
+        return sorted(verdicts_dict.keys())
 
     def getToken(self, context, value):
@@ -50,4 +50,6 @@
     def getTitle(self, context, value):
         verdicts_dict = getUtility(IStudentsUtils).VERDICTS_DICT
+        if value != '0':
+            return verdicts_dict[value] + ' (%s)' % value
         return verdicts_dict[value]
 
@@ -65,5 +67,6 @@
         """
 
-    def setPaymentDetails(category, student):
+    def setPaymentDetails(category, student, previous_session=None,
+            previous_level=None,):
         """Create Payment object and set the payment data of a student for
         the payment category specified.
@@ -151,7 +154,15 @@
     faccode = Attribute('The faculty code of any chosen study course')
     current_session = Attribute('The current session of the student')
+    current_level = Attribute('The current level of the student')
     current_mode = Attribute('The current mode of the student')
     fullname = Attribute('All name parts separated by hyphens')
     display_fullname = Attribute('The fullname of an applicant')
+    is_postgrad = Attribute('True if postgraduate student')
+
+    suspended = schema.Bool(
+        title = _(u'Account suspended'),
+        default = False,
+        required = False,
+        )
 
     student_id = schema.TextLine(
@@ -198,5 +209,5 @@
         title = _(u'PWD Activation Code'),
         required = False,
-        readonly = True,
+        readonly = False,
         )
 
@@ -212,4 +223,10 @@
         )
 
+    def transfer(certificate, current_session,
+        current_level, current_verdict):
+        """ Creates a new studycourse and backups the old one.
+
+        """
+
 class IUGStudentClearance(IKofaObject):
     """Representation of undergraduate student clearance data.
@@ -225,4 +242,5 @@
         title = _(u'Clearance form locked'),
         default = False,
+        required = False,
         )
 
@@ -230,5 +248,5 @@
         title = _(u'CLR Activation Code'),
         required = False,
-        readonly = True,
+        readonly = False,
         )
 
@@ -288,6 +306,6 @@
     login for the the first time.
     """
-    reg_number = schema.TextLine(
-        title = u'Registration Number',
+    number = schema.TextLine(
+        title = _(u'Registr. or Matric. Number'),
         required = True,
         )
@@ -346,5 +364,5 @@
         title = _(u'Current Verdict'),
         source = VerdictSource(),
-        default = 'NY',
+        default = '0',
         required = False,
         )
@@ -353,7 +371,31 @@
         title = _(u'Previous Verdict'),
         source = VerdictSource(),
-        default = 'NY',
-        required = False,
-        )
+        default = '0',
+        required = False,
+        )
+
+class IStudentStudyCourseTransfer(IStudentStudyCourse):
+    """An student transfers.
+
+    """
+
+    certificate = schema.Choice(
+        title = _(u'Certificate'),
+        source = CertificateSource(),
+        required = True,
+        )
+
+    current_level = schema.Choice(
+        title = _(u'Current Level'),
+        source = StudyLevelSource(),
+        required = True,
+        readonly = False,
+        )
+
+
+IStudentStudyCourseTransfer['certificate'].order = IStudentStudyCourse[
+    'certificate'].order
+IStudentStudyCourseTransfer['current_level'].order = IStudentStudyCourse[
+    'current_level'].order
 
 class IStudentVerdictUpdate(IKofaObject):
@@ -385,11 +427,9 @@
     """
     level = Attribute('The level code')
-    validation_date = Attribute('The date of validation')
-    validated_by = Attribute('User Id of course adviser')
 
     level_session = schema.Choice(
         title = _(u'Session'),
         source = academic_sessions_vocab,
-        required = True,
+        required = False,
         )
 
@@ -397,9 +437,21 @@
         title = _(u'Verdict'),
         source = VerdictSource(),
-        default = 'NY',
-        required = False,
-        )
-
-    def addCourseTicket(courseticket):
+        default = '0',
+        required = False,
+        )
+
+    validated_by = schema.TextLine(
+        title = _(u'Validated by'),
+        default = None,
+        required = False,
+        )
+
+    validation_date = schema.Datetime(
+        title = _(u'Validation Date'),
+        required = False,
+        readonly = False,
+        )
+
+    def addCourseTicket(ticket, course):
         """Add a course ticket object.
         """
@@ -520,4 +572,10 @@
     """
 
+    p_current = schema.Bool(
+        title = _(u'Current Session Payment'),
+        default = True,
+        required = False,
+        )
+
     p_level = schema.Int(
         title = _(u'Payment Level'),
@@ -543,4 +601,21 @@
 IStudentOnlinePayment['p_level'].order = IStudentOnlinePayment[
     'p_session'].order
+
+class IStudentPreviousPayment(IOnlinePayment):
+    """An interface for adding previous session payments.
+
+    """
+
+    p_session = schema.Choice(
+        title = _(u'Payment Session'),
+        source = academic_sessions_vocab,
+        required = True,
+        )
+
+    p_level = schema.Choice(
+        title = _(u'Payment Level'),
+        source = StudyLevelSource(),
+        required = True,
+        )
 
 class ICSVStudentExporter(ICSVExporter):
Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/payments.py
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/payments.py	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/payments.py	(revision 9169)
@@ -97,7 +97,8 @@
         """Process student after payment was made.
         """
-        error = self._createActivationCodes()
-        if error is not None:
-            return False, error, error
+        if self.p_current:
+            error = self._createActivationCodes()
+            if error is not None:
+                return False, error, error
         log = 'successful payment: %s' % self.p_id
         msg = _('Successful payment')
@@ -107,7 +108,8 @@
         """Process student after payment was approved.
         """
-        error = self._createActivationCodes()
-        if error is not None:
-            return False, error, error
+        if self.p_current:
+            error = self._createActivationCodes()
+            if error is not None:
+                return False, error, error
         log = 'payment approved: %s' % self.p_id
         msg = _('Payment approved')
Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/student.py
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/student.py	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/student.py	(revision 9169)
@@ -28,4 +28,5 @@
 from zope.interface import implementedBy
 from zope.securitypolicy.interfaces import IPrincipalRoleManager
+from zope.schema.interfaces import ConstraintNotSatisfied
 
 from waeup.kofa.image import KofaImageFile
@@ -130,4 +131,10 @@
 
     @property
+    def current_level(self):
+        level = getattr(
+            self.get('studycourse', None), 'current_level', None)
+        return level
+
+    @property
     def current_mode(self):
         certificate = getattr(
@@ -142,4 +149,41 @@
             self.get('studycourse', None), 'is_postgrad', False)
         return is_postgrad
+
+    def transfer(self, certificate, current_session=None,
+        current_level=None, current_verdict=None, previous_verdict=None):
+        """ Creates a new studycourse and backups the old one.
+
+        """
+        studycourse = createObject(u'waeup.StudentStudyCourse')
+        try:
+            studycourse.certificate = certificate
+            studycourse.entry_mode = 'transfer'
+            studycourse.current_session = current_session
+            studycourse.current_level = current_level
+            studycourse.current_verdict = current_verdict
+            studycourse.previous_verdict = previous_verdict
+        except ConstraintNotSatisfied:
+            return -1
+        old = self['studycourse']
+        if getattr(old, 'entry_session', None) is None or\
+            getattr(old, 'certificate', None) is None:
+            return -2
+        studycourse.entry_session = old.entry_session
+        # Students can be transferred only two times.
+        if 'studycourse_1' in self.keys():
+            if 'studycourse_2' in self.keys():
+                return -3
+            self['studycourse_2'] = old
+        else:
+            self['studycourse_1'] = old
+        del self['studycourse']
+        self['studycourse'] = studycourse
+        self.__parent__.logger.info(
+            '%s - transferred from %s to %s' % (
+            self.student_id, old.certificate.code, studycourse.certificate.code))
+        history = IObjectHistory(self)
+        history.addMessage('Transferred from %s to %s' % (
+            old.certificate.code, studycourse.certificate.code))
+        return
 
 
Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/studycourse.py
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/studycourse.py	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/studycourse.py	(revision 9169)
@@ -61,6 +61,13 @@
     @property
     def is_postgrad(self):
+        if self.certificate is None:
+            return False
         return self.certificate.study_mode.startswith('pg')
-        #return cert.start_level == 999 or cert.end_level == 999
+
+    @property
+    def is_current(self):
+        if '_' in self.__name__:
+            return False
+        return True
 
     def addStudentStudyLevel(self, cert, studylevel):
Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/studylevel.py
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/studylevel.py	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/studylevel.py	(revision 9169)
@@ -37,6 +37,4 @@
         super(StudentStudyLevel, self).__init__()
         self.level = None
-        self.validation_date = None
-        self.validated_by = None
         return
 
@@ -56,11 +54,18 @@
         return studylevelsource.factory.getTitle(self.__parent__, self.level)
 
-    def addCourseTicket(self, courseticket):
+    def addCourseTicket(self, ticket, course):
         """Add a course ticket object.
         """
-        if not ICourseTicket.providedBy(courseticket):
+        if not ICourseTicket.providedBy(ticket):
             raise TypeError(
                 'StudentStudyLeves contain only ICourseTicket instances')
-        self[courseticket.code] = courseticket
+        ticket.code = course.code
+        ticket.title = course.title
+        ticket.fcode = course.__parent__.__parent__.__parent__.code
+        ticket.dcode = course.__parent__.__parent__.code
+        ticket.credits = course.credits
+        ticket.passmark = course.passmark
+        ticket.semester = course.semester
+        self[ticket.code] = ticket
         return
 
@@ -87,6 +92,7 @@
 
     A course ticket contains a copy of the original course and
-    course referrer data. If the courses and/or their referrers are removed, the
-    corresponding tickets remain unchanged. So we do not need any event
+    certificate course data. If the courses and/or the referrin certificate
+    courses are removed, the corresponding tickets remain unchanged.
+    So we do not need any event
     triggered actions on course tickets.
     """
Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/tests/test_authentication.py
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/tests/test_authentication.py	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/tests/test_authentication.py	(revision 9169)
@@ -65,4 +65,5 @@
     email = None
     phone = None
+    suspended = False
 
 
